// AviToSaturnDlg.cpp : implementation file
//

#include "stdafx.h"
#include <vfw.h>
#include "AviToSaturn.h"
#include "AviToSaturnDlg.h"
#include "CpkFile.h"
#include <process.h>
#include <io.h>
#include <fcntl.h>
#include <direct.h>
#include <sys/stat.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char* const DirectoryList[] =
{
	"c:\\Temp",
	NULL
};

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAviToSaturnDlg dialog

CAviToSaturnDlg::CAviToSaturnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAviToSaturnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAviToSaturnDlg)
	m_sFilename = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_nPos = 10000;
	m_bStarted = FALSE;
	m_bAborted = FALSE;
	m_nFileCount = 0;
}

void CAviToSaturnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAviToSaturnDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_ctrlSetRate);
	DDX_Control(pDX, IDC_TREE1, m_ctrlTree);
	DDX_Control(pDX, IDC_PROGRESS1, m_ctrlProgress);
	DDX_Text(pDX, IDC_FILENAME, m_sFilename);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAviToSaturnDlg, CDialog)
	//{{AFX_MSG_MAP(CAviToSaturnDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ABORT, OnAbort)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_ADDFILES, OnAddfiles)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAviToSaturnDlg message handlers

BOOL CAviToSaturnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_ctrlSetRate.SetRange(0,10000,TRUE);
	m_ctrlSetRate.SetPos(10000);
	SetDlgItemInt(IDC_RATE,10000);
	
//	long		hFD,
//				nFileCount = 0;
//	_finddata_t	fd;
//	HTREEITEM	hTI;
//
//	for ( int i = 0 ; DirectoryList[i] != NULL ; i++)
//	{
//		hTI = m_ctrlTree.InsertItem(DirectoryList[i]);
//
//		if ( -1 == _chdir(DirectoryList[i]))
//			continue;
//		
//		hFD = _findfirst("*.avi", &fd);
//		if ( -1 == hFD)
//			continue;
//
//		do
//		{
//			m_ctrlTree.InsertItem( fd.name, hTI, TVI_SORT);
//			nFileCount++;
//		}
//		while ( nFileCount < 5 && -1 != _findnext(hFD,&fd));
//	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAviToSaturnDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAviToSaturnDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAviToSaturnDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAviToSaturnDlg::OnOK() 
{
	UINT ProcessingThread(LPVOID);
	
	// TODO: Add extra validation here
	GetDlgItem(IDOK)->EnableWindow(FALSE);
	m_ctrlSetRate.EnableWindow(FALSE);

#define STACK_SIZE	0x100000
	m_pProcessingThread = AfxBeginThread( ProcessingThread, this, THREAD_PRIORITY_HIGHEST, STACK_SIZE);

//	CDialog::OnOK();
}

void CAviToSaturnDlg::OnAbort() 
{
	// TODO: Add your control notification handler code here
	RequestAbort();
}

void CAviToSaturnDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	RequestAbort();

//	CDialog::OnClose();
}

BOOL CAviToSaturnDlg::Processing(void)
{
	if (m_bAborted)
		return TRUE;	//FALSE;
	else
		return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////

const char* const OddXVideoList[] =
{
//	"ANM01NV1",
//	"ANM02WV1",
//	"ANM02WV2",
//	"ANMZ02V1",
//	"ANMZ03V1",
//	"BDBZ01V1",
//	"CAR02NV1",
//	"CAR02NV2",
//	"CARZ04A1",
//	"CHMZ01AI",
//	"CZ1CSN",
//	"CZ1DREEG",
//	"CZ1DTE",
//	"CZ1DTEG",
//	"CZ1ECCE",
//	"CZ1ECEC",
//	"CZ1ECEE",
//	"CZ1ECEO",
//	"CZ1ECEY",
//	"CZ1ECGC",
//	"CZ1ECGE",
//	"CZ1ECOE",
//	"CZ1ESC",
//	"CZ1ESY",
//	"CZ1SEE",
//	"CZ1SSC",
//	"CZ1SSO",
//	"CZ1UREEG",
//	"CZ1UTE",
//	"CZ1UTEG",
//	"CZ1UTG",
//	"CZ1WTCE",
//	"CZ1WTEC",
//	"CZ1WTEE",
//	"CZ1WTEO",
//	"CZ1WTEY",
//	"CZ1WTGC",
//	"CZ1WTGE",
//	"CZ1WTOE",
//	"CZ1Z01FL",
//	"CZ1Z01WT",
//	"CZ1Z2A1",
//	"CZ1Z2A1Y",
//	"DUN01SA1",
//	"DUN01SA2",
//	"DUN01SA3",
//	"ENG01A5",
//	"GRH03NV1",
//	"GRH03NV2",
//	"GRH03NV3",
//	"GRHZ07A1",
//	"GRHZ07A2",
//	"HDG34EA1",
//	"HDGZ01A1",
//	"LABZ01V3",
//	"LIBZ04A1",
//	"OBS02EV2",
//	"OBS02EV3",
//	"OBS02NV1",
//	"OBS03SV1",
//	"OBS03WV5",
//	"OBS03WV6",
//	"PERVID07",
//	"PS104EA2",
//	"PS106NA2",
//	"PS106NA3",
//	"REF01SA",
//	"REF2PEXT",
//	"REF2PRTR",
//	"REF3PEXT",
//	"REF3PRTR",
//	"REFH2R",
//	"REFH3R",
//	"REFV1CR",
//	"REFV1RE",
//	"REFV2CE",
//	"REFV2RE",
//	"REFV3CF",
//	"REFV4R",
//	"REFZDRR",
//	"RSU01NV1",
//	"RSU02WV1",
//	"RSU03NV1",
//	"RSU04SV2",
//	"RSU05SA1",
//	"RSU06SV1",
//	"RSUZ04V2",
//	"RSUZ04V3",
//	"RSUZ05V1",
//	"RSUZ09A1",
//	"SECZ02A1",
//	"SED01NV1",
//	"STMZ02V1",
//	"STMZ02V2",
//	"TROZ05A1",
//	"TROZ05A2",
//	"WATZ01A1",
//	"WFM02EV1",
//	"WFM11SA1",
//	"WLG02WV1",
//	"WLKZ02A1",
//	"WLKZ02A2",
//	"WLKZ03A1",
//	"WLKZ03A2",
//	"WTR01SV1",
//	"WTR04WV1",
//	"WTR04WV2",
//	"WTRZ01A1",
//	"WTRZ01A2",
	NULL
};

const char* const BackwardVideoList[] =
{
//	"CZ1Z2A1",
//	"CZ1Z2A1Y",
//	"ENG01A4",
//	"GRH01SA1",
//	"LIBZ04A1",
//	"OBS02SA1",
//	"PS104EA1",
//	"PS104EA2",
//	"PS5Z01A1",
//	"PS5Z01A2",
//	"PS5Z01A3",
//	"RSU06EA1",
//	"RSU06EA2",
//	"RSU06EA3",
//	"RSU06EA4",
//	"SED16WA1",
	NULL
};

const char* const QuietVideoList[] =
{
//	"PLAZ06A1",
	NULL
};

BOOL IsOddXVideo( const char* const sFilename)
{
	char	drive[_MAX_DRIVE],
			dir[_MAX_DIR],
			fname[_MAX_FNAME],
			ext[_MAX_EXT];

	_splitpath( sFilename, drive, dir, fname, ext);

	for ( int i = 0 ; OddXVideoList[i] != NULL ; i++)
	{
		if ( 0 == stricmp( fname, OddXVideoList[i]))
			return TRUE;
	}

	return FALSE;
}

BOOL IsBackwardVideo( const char* const sFilename)
{
	char	drive[_MAX_DRIVE],
			dir[_MAX_DIR],
			fname[_MAX_FNAME],
			ext[_MAX_EXT];

	_splitpath( sFilename, drive, dir, fname, ext);

	for ( int i = 0 ; BackwardVideoList[i] != NULL ; i++)
	{
		if ( 0 == stricmp( fname, BackwardVideoList[i]))
			return TRUE;
	}

	return FALSE;
}

BOOL IsQuietVideo( const char* const sFilename)
{
	char	drive[_MAX_DRIVE],
			dir[_MAX_DIR],
			fname[_MAX_FNAME],
			ext[_MAX_EXT];

	_splitpath( sFilename, drive, dir, fname, ext);

	for ( int i = 0 ; QuietVideoList[i] != NULL ; i++)
	{
		if ( 0 == stricmp( fname, QuietVideoList[i]))
			return TRUE;
	}

	return FALSE;
}


UINT ProcessingThread( LPVOID pParm)
{
	char			*	lpBuf;
	int					vidShift,
						quality;
	long				i,
						w, h,
						W, H,
						cBytes,
						cBytesTotal,
						dataRate,
						avgDataRate,
						maxDataRate,
						nBufSize,
						nFirstFrame,
						nLastFrame;
	BOOL				bBackward,
						bQuiet;
	DWORD				dwTemp;
	COLORREF			colorBgnd;
	HANDLE				hDibCompressed;
	HIC					hICCompressor;
	PAVIFILE			pSrcFile;
	PAVISTREAM			pSrcAudioStream,
						pSrcVideoStream;
	AVISTREAMINFO		streamAudioInfo,
						streamVideoInfo;
	PGETFRAME			pGetFrame;
	WAVEFORMATEX		pcmSrc;
	BITMAPINFO			bmiSrc,
						bmiDst,
						bmiShrink,
					*	pDib,
					*	pShrinkDib;
	HTREEITEM			hTreeItem,
						hChildItem;
	HDRAWDIB			hDD = DrawDibOpen();
	CString				sFilename;
	CRect				rect;
	CWnd			*	pWnd;
	CAviToSaturnDlg	*	pDlg = (CAviToSaturnDlg*)pParm;
	CClientDC			dc(pDlg);
	CCpkFile			cpkFile;

	void ShrinkDib( BITMAPINFO*, const BITMAPINFO*, int shift);

	quality = pDlg->m_ctrlSetRate.GetPos();

	AVIFileInit();

	for ( hTreeItem = pDlg->m_ctrlTree.GetRootItem() ; hTreeItem != NULL ; hTreeItem = pDlg->m_ctrlTree.GetNextItem(hTreeItem,TVGN_NEXT) )
	{
		if ( pDlg->IsAborted() )
			break;

		pDlg->m_ctrlTree.Select(hTreeItem,TVGN_FIRSTVISIBLE);
		for ( hChildItem = pDlg->m_ctrlTree.GetChildItem(hTreeItem) ; hChildItem != NULL ; hChildItem = pDlg->m_ctrlTree.GetNextItem(hChildItem,TVGN_NEXT) )
		{
			if ( pDlg->IsAborted() )
				break;

			pDlg->m_ctrlProgress.SetPos(0);	// Reset Progress Bar for new file.
			pDlg->GetDlgItem(IDC_PICTURE)->Invalidate(TRUE);

			pDlg->m_ctrlTree.Select(hChildItem,TVGN_CARET);
			pDlg->m_sFilename = pDlg->m_ctrlTree.GetItemText(hTreeItem);
			pDlg->m_sFilename += "\\";
			pDlg->m_sFilename += pDlg->m_ctrlTree.GetItemText(hChildItem);
			i = pDlg->m_sFilename.GetLength();
			pDlg->SetDlgItemText(IDC_FILENAME,pDlg->m_sFilename);

			//	Open Source AVI and Destination CPK files.

			sFilename = pDlg->m_sFilename;

			if ( IsOddXVideo(sFilename))
				vidShift = 1;
			else
				vidShift = 0;

			if ( IsBackwardVideo(sFilename))
				bBackward = TRUE;
			else
				bBackward = FALSE;

			if ( IsQuietVideo(sFilename))
				bQuiet = TRUE;
			else
				bQuiet = FALSE;

//			// Just redo the OddX videos.
//			if ( vidShift == 0)
//				continue;
			// Just redo the Backward videos.
//			if ( bBackward == FALSE)
//				continue;

			AVIFileOpen( &pSrcFile, sFilename, OF_READ, NULL);
			if ( pSrcFile == NULL)
				continue;

			sFilename = sFilename.Left( sFilename.ReverseFind('.'));
			if (bBackward)
				sFilename += ".rev";
			else
				sFilename += ".cpk";
			cpkFile.Open( sFilename, CFile::modeCreate|CFile::modeWrite);

		//	Open Source AVI and Destination CPK streams.

			AVIFileGetStream( pSrcFile, &pSrcVideoStream, streamtypeVIDEO, 0);
			if ( pSrcVideoStream == NULL)
			{
				AVIFileRelease(pSrcFile);
				cpkFile.Close();
				continue;
			}
			if ( !bQuiet)
				AVIFileGetStream( pSrcFile, &pSrcAudioStream, streamtypeAUDIO, 0);
			else
				pSrcAudioStream = NULL;

			cpkFile.OpenStreams();

		//	Get Source stream format information.

			i = sizeof(BITMAPINFOHEADER);
			AVIStreamReadFormat( pSrcVideoStream, 0, &bmiSrc, &i);
			AVIStreamInfo( pSrcVideoStream, &streamVideoInfo, sizeof(streamVideoInfo));

			if (pSrcAudioStream)
			{
				i = sizeof(WAVEFORMATEX);
				AVIStreamReadFormat( pSrcAudioStream, 0, &pcmSrc, &i);
				AVIStreamInfo( pSrcAudioStream, &streamAudioInfo, sizeof(streamAudioInfo));
			}

			bmiShrink = bmiSrc;
//Demo		bmiShrink.bmiHeader.biWidth /= 2;
			bmiShrink.bmiHeader.biSizeImage = (((bmiShrink.bmiHeader.biBitCount*bmiShrink.bmiHeader.biWidth+31) & ~31)/8) * bmiShrink.bmiHeader.biHeight;
			SetRect( &streamVideoInfo.rcFrame, 0,0, bmiShrink.bmiHeader.biWidth, bmiShrink.bmiHeader.biHeight);

			pShrinkDib = (BITMAPINFO*) malloc( sizeof(BITMAPINFO)+bmiShrink.bmiHeader.biSizeImage);
			ASSERT(pShrinkDib);

			pDlg->m_ctrlProgress.SetRange32( AVIStreamStart(pSrcVideoStream), AVIStreamEnd(pSrcVideoStream));
			pDlg->m_ctrlProgress.SetStep(1);

			AVISTREAMINFO info;
			AVIStreamInfo(pSrcVideoStream,&info, sizeof(info));
			dwTemp = AVIStreamEnd(pSrcVideoStream)-AVIStreamStart(pSrcVideoStream);
			cpkFile.SetVideoInfo( dwTemp, info.dwRate, info.dwScale, bmiShrink);

			if (pSrcAudioStream)
			{
				dwTemp = AVIStreamEnd(pSrcAudioStream)-AVIStreamStart(pSrcAudioStream);
				cpkFile.SetAudioInfo( dwTemp, pcmSrc);
			}
			else
				cpkFile.SetAudioInfo( 0, pcmSrc);
		
			cpkFile.WriteHeader();

			nBufSize = (((bmiSrc.bmiHeader.biBitCount*bmiSrc.bmiHeader.biWidth+31) & ~31)/8) * bmiSrc.bmiHeader.biHeight;
			bmiDst = bmiSrc;
			bmiDst.bmiHeader.biCompression = BI_RGB;

			hICCompressor = ICOpen( ICTYPE_VIDEO, 'divc', ICMODE_COMPRESS);

			pWnd = pDlg->GetDlgItem(IDC_PICTURE);
			pWnd->GetClientRect(rect);
			pWnd->MapWindowPoints(pDlg,rect);

			colorBgnd = ::GetSysColor(COLOR_WINDOW);
			dc.FillSolidRect(rect,colorBgnd);

			pGetFrame = AVIStreamGetFrameOpen( pSrcVideoStream, NULL);
			if ( pGetFrame == NULL)
			{
				free(pShrinkDib);
				cpkFile.CloseStreams();
				cpkFile.Close();
				if (pSrcAudioStream)
					AVIStreamRelease(pSrcAudioStream);
				AVIStreamRelease(pSrcVideoStream);
				AVIFileRelease(pSrcFile);
				ICClose(hICCompressor);
				AfxMessageBox("Unable to decompress; possibly non-'cvid' compression.", MB_OK);
				continue;
			}

			cBytesTotal = 0;
			maxDataRate = 0;

			nFirstFrame = AVIStreamStart(pSrcVideoStream);
			nLastFrame = AVIStreamEnd(pSrcVideoStream) - 1;
			for ( i = nFirstFrame ; i <= nLastFrame ; i++)
			{
				if ( pDlg->IsAborted())
					break;

				if (bBackward)
					pDib = (BITMAPINFO*) AVIStreamGetFrame( pGetFrame, nLastFrame-i);
				else
					pDib = (BITMAPINFO*) AVIStreamGetFrame( pGetFrame, i);

				ShrinkDib( pShrinkDib, pDib, vidShift);

				// Downscale images that are bigger than Picture window.
				w = pShrinkDib->bmiHeader.biWidth;
				h = pShrinkDib->bmiHeader.biHeight;
				if ( w <= rect.Width() && h <= rect.Height())
				{
					W = w;
					H = h;
				}
				else
				{
					if ( h*rect.Width() <= w*rect.Height())
					{
						W = rect.Width();
						H = h*rect.Width()/w;
					}
					else
					{
						W = w*rect.Height()/h;
						H = rect.Height();
					}
				}
				DrawDibDraw( hDD, dc.GetSafeHdc(),
					rect.left,rect.top,
					W,H,
					(BITMAPINFOHEADER*)pShrinkDib,
					(char*)pShrinkDib+sizeof(BITMAPINFOHEADER),
					0,0,
					w,h,
					0 );

				cBytes = nBufSize/2;
				hDibCompressed = ICImageCompress( hICCompressor, 0, pShrinkDib, (char*)pShrinkDib+sizeof(BITMAPINFOHEADER), &bmiShrink, quality, &cBytes);

				cBytesTotal += cBytes;
				dataRate = cBytes*(info.dwRate/info.dwScale) + pcmSrc.nSamplesPerSec;
				avgDataRate = cBytesTotal*(info.dwRate/info.dwScale)/(i-nFirstFrame+1) + pcmSrc.nSamplesPerSec;
				if ( dataRate > maxDataRate)
				{
					maxDataRate = dataRate;
					pDlg->SetDlgItemInt(IDC_MAXDATARATE,maxDataRate/1000);
				}
				pDlg->SetDlgItemInt(IDC_DATARATE,avgDataRate/1000);

				pDib = (BITMAPINFO*) GlobalLock(hDibCompressed);
				cpkFile.WriteVideoStream( (char*)pDib+sizeof(BITMAPINFOHEADER), cBytes);
				GlobalUnlock(hDibCompressed);
				GlobalFree(hDibCompressed);

				pDlg->m_ctrlProgress.StepIt();
			}

			free(pShrinkDib);
			AVIStreamGetFrameClose(pGetFrame);
			AVIStreamRelease(pSrcVideoStream);

			if ( ! pDlg->IsAborted() )
			{
				if ( pSrcAudioStream != NULL)
				{
					nBufSize = streamAudioInfo.dwLength - streamAudioInfo.dwStart;
					lpBuf = (char*) malloc(nBufSize);
					ASSERT(lpBuf);
					AVIStreamRead( pSrcAudioStream, streamAudioInfo.dwStart, streamAudioInfo.dwLength-streamAudioInfo.dwStart, lpBuf, nBufSize, &cBytes, NULL);
					cpkFile.WriteAudioStream( lpBuf, cBytes);
					free(lpBuf);
				}
			}

			cpkFile.CloseStreams();
			cpkFile.Close();
			if (pSrcAudioStream)
				AVIStreamRelease(pSrcAudioStream);
			AVIFileRelease(pSrcFile);
			ICClose(hICCompressor);
		}
	}

	DrawDibClose(hDD);
	pDlg->RequestAbort();

	AVIFileExit();
	return 0;
}

void ShrinkDib( BITMAPINFO* pRetDib, const BITMAPINFO* pDib, int pixShift)
{
//	WORD			red,
//					grn,
//					blu;
	int				/*i,*/ j,
//					k1, k2,
					w = pDib->bmiHeader.biWidth,
					h = pDib->bmiHeader.biHeight,
					byteWidthSrc = ((w * pDib->bmiHeader.biBitCount+31) & ~31) / 8,
//Demo				byteWidthDst = (((w/2) * pDib->bmiHeader.biBitCount+31) & ~31) / 8;
					byteWidthDst = byteWidthSrc;	//Demo
	RGBTRIPLE	*	pRgbSrc,
				*	pRgbDst;

	*pRetDib = *pDib;

	for ( j = 0 ; j < h ; j++)
	{
		pRgbSrc = (RGBTRIPLE*) ((char*) pDib + sizeof(BITMAPINFOHEADER) + j*byteWidthSrc);
		pRgbDst = (RGBTRIPLE*) ((char*) pRetDib + sizeof(BITMAPINFOHEADER) + j*byteWidthDst);

		memcpy( pRgbDst, pRgbSrc, byteWidthSrc);

//Demo	if (pixShift)
//Demo		pRgbDst[0] = pRgbSrc[0];
//Demo	for ( i = 0 ; i < (w/2) ; i++)
//Demo	{
//Demo		k1 = 2*i + pixShift;
//Demo		k2 = 2*i - pixShift + 1;
//Demo		red = ( (WORD)pRgbSrc[k1].rgbtRed*3 + (WORD)pRgbSrc[k2].rgbtRed ) / 4;
//Demo		grn = ( (WORD)pRgbSrc[k1].rgbtGreen*3 + (WORD)pRgbSrc[k2].rgbtGreen ) / 4;
//Demo		blu = ( (WORD)pRgbSrc[k1].rgbtBlue*3 + (WORD)pRgbSrc[k2].rgbtBlue ) / 4;
//Demo		pRgbDst[i+pixShift].rgbtRed = (BYTE)(red & 0xff);
//Demo		pRgbDst[i+pixShift].rgbtGreen = (BYTE)(grn & 0xff);
//Demo		pRgbDst[i+pixShift].rgbtBlue = (BYTE)(blu & 0xff);
//Demo	}
	}

//Demo	pRetDib->bmiHeader.biWidth = w/2;
	pRetDib->bmiHeader.biSizeImage = h * byteWidthDst;
}

BOOL CAviToSaturnDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class

	if ( wParam == IDC_SLIDER1)
	{
		m_nPos = m_ctrlSetRate.GetPos();
		SetDlgItemInt(IDC_RATE,m_nPos);
	}

	return CDialog::OnNotify(wParam, lParam, pResult);
}

void CAviToSaturnDlg::OnAddfiles() 
{
	static const char*	strFilters = "AVI Files\0*.avi\0All Files\0*.*\0\0";

	// TODO: Add your control notification handler code here
	CFileDialog	fileDlg(TRUE,"*.avi",NULL,
		OFN_ALLOWMULTISELECT|OFN_EXPLORER|OFN_FILEMUSTEXIST,
		strFilters);

	// Demo version limit.
	if ( m_nFileCount >= 5)
	{
		AfxMessageBox( "Demo version is limited to five files. You've already selected them.",
			MB_ICONEXCLAMATION);
		return;
	}

	fileDlg.m_ofn.nFilterIndex = 1;
	fileDlg.m_ofn.lpstrCustomFilter = NULL;
	fileDlg.m_ofn.nMaxFile = 10000;
	fileDlg.m_ofn.lpstrFile = new char [fileDlg.m_ofn.nMaxFile];
	strcpy(fileDlg.m_ofn.lpstrFile, "*.avi");
	fileDlg.m_ofn.lpstrInitialDir = NULL;
	fileDlg.m_ofn.lpstrTitle = "Select AVI Files (DEMO 5 FILE LIMIT)";
		
	if ( IDOK == fileDlg.DoModal())
	{
		char	*	pFilename,
				*	ptr;
		HTREEITEM	hTI;

		pFilename = fileDlg.m_ofn.lpstrFile;
		ptr = pFilename + strlen(pFilename) + 1;

		if ( *ptr == '\0')
		{	// Single selection.
			ptr = pFilename + fileDlg.m_ofn.nFileOffset;
			*(ptr-1) = '\0';
			hTI = m_ctrlTree.InsertItem(pFilename);
			m_ctrlTree.InsertItem( ptr, hTI, TVI_SORT);
			m_nFileCount++;
		}
		else
		{
			hTI = m_ctrlTree.InsertItem(pFilename);
			pFilename = ptr;

			for ( int i = m_nFileCount ; *pFilename != '\0' && i < 5 /*Demo limit*/; i++, pFilename += strlen(pFilename)+1 )
			{
				m_ctrlTree.InsertItem( pFilename, hTI, TVI_SORT);
				m_nFileCount++;
			}
		}
	}

	delete fileDlg.m_ofn.lpstrFile;
}
