// AviToSaturnDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAviToSaturnDlg dialog

class CAviToSaturnDlg : public CDialog
{
// Construction
public:
	BOOL Processing(void);
	CAviToSaturnDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAviToSaturnDlg)
	enum { IDD = IDD_AVITOSATURN_DIALOG };
	CSliderCtrl	m_ctrlSetRate;
	CTreeCtrl	m_ctrlTree;
	CProgressCtrl	m_ctrlProgress;
	CString	m_sFilename;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAviToSaturnDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementation
protected:
	int				m_nPos;
	HICON			m_hIcon;
	BOOL			m_bStarted,
					m_bAborted;
	DWORD			m_idProcessingThread;
	CWinThread	*	m_pProcessingThread;
	int				m_nFileCount;

	// Generated message map functions
	//{{AFX_MSG(CAviToSaturnDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnAbort();
	afx_msg void OnClose();
	afx_msg void OnAddfiles();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void	RequestAbort(void)
				{
					m_bStarted = FALSE;
					m_bAborted = TRUE;
				}
	BOOL	IsStarted(void)
				{
					return m_bStarted;
				}
	BOOL	IsAborted(void)
				{
					return m_bAborted;
				}
};
